unit UOngletsPdx;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, DBCtrls, StdCtrls, Grids, DBGrids, DB,
  DBTables, ExtDlgs, Mask, ADODB;


type TDBGridPlus= class(TDBGrid)
public
function GetEditText(ACol,ARow:Longint):string;override;
end;

type
  TfrmParadox = class(TForm)
    Panel1: TPanel;
    tblFish: TTable;
    dsFish: TDataSource;
    qryFish: TQuery;
    tblClients: TTable;
    dsClients: TDataSource;
    qryClients: TQuery;
    tblEmp: TTable;
    dsEmp: TDataSource;
    qryEmp: TQuery;
    tblVendor: TTable;
    tblVendorVendorNo: TFloatField;
    dsVendor: TDataSource;
    tblVendorVendorName: TStringField;
    tblVendorAddress1: TStringField;
    tblParts: TTable;
    dsParts: TDataSource;
    dbClient: TDatabase;
    dbFish: TDatabase;
    PageControl: TPageControl;
    tbshtPoissons: TTabSheet;
    grdFish: TDBGrid;
    navFish: TDBNavigator;
    memFish: TDBMemo;
    tbshtClients: TTabSheet;
    Label1: TLabel;
    DBGrid1: TDBGrid;
    DBNavigator1: TDBNavigator;
    edtSociete: TEdit;
    cmbxChamps: TComboBox;
    cmbxOperateur: TComboBox;
    cmbxFiltre: TComboBox;
    lsRequete: TListBox;
    btnAjouter: TButton;
    btnExecuter: TButton;
    btnEffacer: TButton;
    btnToutEffacer: TButton;
    tbshtEmployes: TTabSheet;
    Panel2: TPanel;
    DBNavigator2: TDBNavigator;
    tbctrl: TTabControl;
    grdEmp: TDBGrid;
    tbshCompare: TTabSheet;
    tbshtParam: TTabSheet;
    DBGrid3: TDBGrid;
    qryProduct: TQuery;
    rgDataSet: TRadioGroup;
    grdParam: TDBGrid;
    Label2: TLabel;
    Label3: TLabel;
    edtPID: TEdit;
    edtPN: TEdit;
    cbOF: TCheckBox;
    btnMAJ: TButton;
    qryUpdate: TQuery;
    TabSheet1: TTabSheet;
    ADODataSet: TADODataSet;
    ADOTable1: TADOTable;
    ADOQuery1: TADOQuery;
    ADOCon: TADOConnection;
    DBGrid2: TDBGrid;
    dsADO: TDataSource;
    Button1: TButton;
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure tblFishAfterInsert(DataSet: TDataSet);
    procedure edtSocieteChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure cmbxChampsChange(Sender: TObject);
    procedure cmbxChampsSelect(Sender: TObject);
    procedure btnAjouterClick(Sender: TObject);
    procedure btnExecuterClick(Sender: TObject);
    procedure btnToutEffacerClick(Sender: TObject);
    procedure btnEffacerClick(Sender: TObject);
    procedure tbctrlChange(Sender: TObject);
    procedure btnMaitreClick(Sender: TObject);
    procedure rgDataSetClick(Sender: TObject);
    procedure cbOFClick(Sender: TObject);
    procedure btnMAJClick(Sender: TObject);
    procedure grdParamCellClick(Column: TColumn);
    procedure tbshtParamShow(Sender: TObject);
    procedure tbshtClientsShow(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure dsClientsDataChange(Sender: TObject; Field: TField);
  private
    { Dclarations prives }
    function NouveauNumero: integer;
    procedure VoirEnregistrements(qry:TQuery); overload;
    procedure VoirEnregistrements(qry:TQuery; lettre: string); overload;
  public
    { Dclarations publiques }
  end;

var
  frmParadox: TfrmParadox;
  NouveauNumero: integer;

implementation

uses UMaitre;

{$R *.dfm}

procedure TfrmParadox.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
	if (tblFish.State = dsEdit) or (tblFish.State = dsInsert) then
  begin
    case MessageDlg('Vous avez modifi des donnes,'+#13#10+
    'voulez-vous les enregistrer ?', mtConfirmation, mbYesNoCancel,0) of
     mrYes : tblFish.Post;
     mrNo : tblFish.Cancel;
     mrCancel :
      begin
        tblFish.Cancel;
        CanClose := false;
      end;
    end;
  end;
end;

function TfrmParadox.NouveauNumero: integer;
var
	qry: TQuery;
begin
  qry := TQuery.Create(Self);
  try
  	qry.DatabaseName := 'fish';
    qry.SQL.Clear;
    qry.SQL.Add('select max(SpeciesNo) as toto from biolife');
    qry.Open;
    result :=  qry.Fields[0].AsInteger + 1;

//    result :=  qry.FieldbyName('toto').AsInteger + 1;
    //ShowMessage(inttostr(Result));

  finally
    qry.Free;
  end;
end;

procedure TfrmParadox.tblFishAfterInsert(DataSet: TDataSet);

begin
tblFish.FieldByName('SpeciesNo').AsInteger := NouveauNumero;
end;

procedure TfrmParadox.edtSocieteChange(Sender: TObject);
begin
	tblClients.FindNearest([edtSociete.Text]);
end;

procedure TfrmParadox.FormCreate(Sender: TObject);
var
	i : integer;
begin
	// on alimente la cmbxChamps avec les champs de la table
  tblClients.GetFieldNames(cmbxChamps.Items);
  cmbxChamps.ItemIndex := 3;
  cmbxOperateur.ItemIndex := 0;
  // pour voir les valeurs possibles du 1er champ pn doit r-excuter la procdure
  //cmbxChampsSelect(Sender);
  // on cre dynamiquement les onglets sur le TabControl
  tbctrl.Tabs.Add('All');
  for i := 65 to 90 do
  	tbctrl.Tabs.Add(chr(i));
  // on ajuste la taille des onglets de manire  ce qu'ils soient tous visibles
  tbctrl.TabWidth := tbctrl.Width div 27;
end;

procedure TfrmParadox.cmbxChampsChange(Sender: TObject);
begin
ShowMessage('onchange');
end;

procedure TfrmParadox.cmbxChampsSelect(Sender: TObject);
begin
	//  chaque fois que l'on slectionnera un champ, devront apparaitre
  // les valeurs possibles dans la cmbxFiltre
  qryClients.SQL.Clear;
  qryClients.SQL.Add('SELECT DISTINCT ');
  qryClients.SQL.Add( cmbxChamps.Text									 );
  qryClients.SQL.Add('FROM CUSTOMERs ');
  // on execute cette requte
  qryClients.Open;
  ShowMessage(qryClients.SQL.Text);
  cmbxFiltre.Clear;
  while not qryClients.Eof do
  begin
   cmbxFiltre.Items.Add(qryClients.Fields[0].AsString);

    // ou bien
  	//cmbxFiltre.Items.Add(qryClients.FieldbyName(cmbxChamps.Text).AsString);

    qryClients.Next;
  end;
  cmbxFiltre.ItemIndex := 0;
end;

procedure TfrmParadox.btnAjouterClick(Sender: TObject);
var
	s,s1 : string;
begin
	s := cmbxFiltre.Text;
	case tblClients.FieldByName(cmbxChamps.Text).DataType of
   ftString : s := '''' + s + '''';
   ftDateTime: s := '''' + s + '''';
  end;
	s1 := cmbxChamps.Text + cmbxOperateur.Text + s;
  if lsRequete.Items.IndexOf(s1)=-1 then
  	lsRequete.Items.Add(s1)
  else
  	MessageDlg('Ce critre existe dj', mtWarning, [mbOk],0);
end;

procedure TfrmParadox.btnExecuterClick(Sender: TObject);
var
	i : integer;
begin
	if lsRequete.Items.Count = 0 then
  	//Exit;
    begin
    ShowMessage('aucun');
    Exit;
    end;

  // traitement particulier pour le 1er lment de la listbox
  tblClients.Filter := lsRequete.Items[0];
  // pour les lments suivants on boucle
  for i := 1 to lsRequete.Items.Count-1 do
  	tblClients.Filter := tblClients.Filter + ' and ' + lsRequete.Items[i];
  tblClients.Filtered := true; // pour excuter le filtre
  // si on veut voir le filtre qui est excut
  ShowMessage(tblClients.Filter);

end;

procedure TfrmParadox.btnToutEffacerClick(Sender: TObject);
begin
	lsRequete.Clear;
  tblClients.Filter := '';
  tblClients.Filtered := false;
end;

procedure TfrmParadox.btnEffacerClick(Sender: TObject);
begin
	if lsRequete.ItemIndex = -1 then
  	ShowMessage('Que voulez-vous effacer ?')
  else
  begin
  	lsRequete.Items.Delete(lsRequete.ItemIndex);
    // pour automatiquement re-excuter le filtre
    // btnExecuterClick(Sender);
  end;
end;

procedure TfrmParadox.tbctrlChange(Sender: TObject);
begin
 {	if tbctrl.TabIndex > 0 then
  begin
  	//on dfinit la borne de dbut d'intervalle
    tblEmp.SetRangeStart;
    tblEmp.FieldByName('LastName').AsString := tbctrl.Tabs[tbctrl.TabIndex] +' ';
  	//on dfinit la borne de fin d'intervalle
    tblEmp.SetRangeEnd;
    tblEmp.FieldByName('LastName').AsString := tbctrl.Tabs[tbctrl.TabIndex] +'~';
    // on applique l'intervalle
    tblEmp.ApplyRange;
  end
  else
  begin
  	tblEmp.CancelRange;
    // pour viter le problme d'affichage
    tblEmp.First;
  end;}
  // si on utilise un query
  if tbctrl.TabIndex > 0 then
    VoirEnregistrements(qryEmp,tbctrl.Tabs[tbctrl.TabIndex])
  else
  	VoirEnregistrements(qryEmp);
  qryEmp.Open;
end;

procedure TfrmParadox.VoirEnregistrements(qry: TQuery);
begin
	qry.SQL.Clear;
  qry.SQL.Add('SELECT * FROM EMPLOYEEs');
  //qry.Open;
end;

procedure TfrmParadox.VoirEnregistrements(qry: TQuery; lettre: string);
begin
	VoirEnregistrements(qry);
  qry.SQL.Add('WHERE LASTNAME like ''' + lettre + '%''');
end;

procedure TfrmParadox.btnMaitreClick(Sender: TObject);
begin
	frmMaitre := TfrmMaitre.Create(Application);
  try
    frmMaitre.ShowModal;
  finally
    frmMaitre.Free;
  end;

end;
procedure TfrmParadox.rgDataSetClick(Sender: TObject);
begin
case rgDataSet.ItemIndex of
  	0 : begin
        	qryProduct.Close;
          dsClients.DataSet := tblclients;
        //tblClients.Filter:='city = ''london''';
          //  tblClients.Filtered :=true;
          tblclients.Open;
    		end;
  	1 : begin
        	tblclients.Close;
          dsClients.DataSet := qryProduct;
          qryProduct.Filter:='ProductID >20';
          qryProduct.Filtered :=true;
          qryProduct.Open;
    		end;
  end;
end;

procedure TfrmParadox.cbOFClick(Sender: TObject);
begin
  dsClients.DataSet:=qryProduct;
  qryProduct.Active := cbOF.Checked;
  btnMAJ.Enabled:= cbOF.Checked;
  if   cbOF.Checked  = true then
    begin
      edtPID.Text :=grdParam.Fields[0].AsString;
      edtPN.Text :=grdParam.Fields[1].AsString;
    end
    else
    begin
      edtPID.Text :='';
      edtPN.Text :='';
    end;

end;

procedure TfrmParadox.btnMAJClick(Sender: TObject);
begin
qryUpdate.ParamByName('pID').AsInteger := StrToInt(edtPID.Text);
    qryUpdate.ParamByName('pName').AsString := edtPN.Text;
    qryUpdate.ExecSQL;
    // pour le pb de sautillements
    qryProduct.DisableControls;
    try
    	// pour rafraichir
    	qryProduct.Close;
      qryProduct.SQL.Clear;
      qryProduct.SQL.Add('select ProductID, ProductName from products  order by ProductID');
     	qryProduct.Open;
    finally
      qryProduct.EnableControls;
    end;
end;

{ TDBGridPlus }

function TDBGridPlus.GetEditText(ACol, ARow: Integer): string;
begin
    Result:=InHerited GetEditText(ACol,ARow);
end;

procedure TfrmParadox.grdParamCellClick(Column: TColumn);
begin
//edtPID.Text :=TDBGridPlus(DBGrid4).GetEditText(1,1);
//edtPN.Text :=TDBGridPlus(DBGrid4).GetEditText(2,1);
end;

procedure TfrmParadox.tbshtParamShow(Sender: TObject);
begin
tblClients.Close;
qryProduct.Close;
end;

procedure TfrmParadox.tbshtClientsShow(Sender: TObject);
begin
tblClients.Open;
dsClients.DataSet:=tblClients;

end;

procedure TfrmParadox.Button1Click(Sender: TObject);
begin
ADODataSet.Close;
ADODataSet.Filter:='ProductID > 4';
ADODataSet.Open;
ADODataSet.Filtered:=true;
end;

procedure TfrmParadox.dsClientsDataChange(Sender: TObject; Field: TField);
begin
edtPN.Text:=grdParam.Fields[1].AsString;
edtPid.Text:=grdParam.Fields[0].AsString;
end;

end.



